/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Incorporate command
 *  File        : inc.c
 *  Version     : 2.20
 *  First Edit  : 1994-06/21
 *  Last  Edit  : 1997-12/23
 *  Author      :  
 *
 */

#include	"compat.h"
#if	defined(POP3) || defined(MSPL)
#include	"pop3lib.h"
#include	"termlib.h"
#endif	/* (POP3 || MSPL) */
#include	"mmh.h"

#ifdef	POP3
extern char	auth_file[];		/* 桼ǧڥե	*/
#endif	/* POP3 */

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
char	user_name[SMALL_BUFF] = "";
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"file",		FILE_MASK},
  {"width",		NUMBER_MASK},
  {"truncate",		0},
  {"notruncate",	0},
  {"silent",		0},
  {"nosilent",		0},
#ifdef	MIME
  {"mime",		0},
  {"nomime",		0},
#endif	/* MIME */
#if	defined(POP3) || defined(MSPL)
  {"host",		HOST_MASK},
#else	/* !(POP3 || MSPL) */
  {"",			HOST_MASK},
#endif	/* !(POP3 || MSPL) */
  {"user",		USER_MASK},
};
static char		folder_perm[SMALL_BUFF];
static char		msg_perm[SMALL_BUFF];
static char		inc_opt[SMALL_BUFF];
static char		default_folder[SMALL_BUFF];
#if	defined(POP3) || defined(MSPL)
static char		pop3_host[MAXHOSTNAMELEN];
#endif	/* (POP3 || MSPL) */
static struct cpy_hdr	inc_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {MH_DEFAULT_FIELD,	default_folder,	sizeof(default_folder)},
  {MH_F_PERM_FIELD,	folder_perm,	sizeof(folder_perm)},
  {MH_M_PERM_FIELD,	msg_perm,	sizeof(msg_perm)},
  {"incopt:",		inc_opt,	sizeof(inc_opt)},
};
static int		s_flag = 0;

static int	inc_message();		/* å	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
#ifndef	MSDOS
  struct passwd	*passwd;
#endif	/* !MSDOS */
  int		status;
  int		i, j;
  int		f_flag = 0;
  int		r_flag = -1;
  int		t_flag = 0;
  int		perm;
  char		buff[PATH_BUFF];
  char		spool_file[PATH_BUFF];
  char		*ptr, *ptr2;
  char		*user;
  int		target;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }
#if	defined(POP3) || defined(MSPL)
  pop3_connect_mode = 0;
#endif	/* (POP3 || MSPL) */

  /*
   * ե졼
   */

  if (get_environ(inc_option, sizeof(inc_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }
#ifdef	POP3
  sprintf(auth_file, "%s%s", home_dir, AUTHORITY_FILE);
#endif	/* POP3 */

  user = (char*)NULL;

  /*
   * åβ
   */

  ptr2 = inc_opt;
  t_flag = 1;
  if (default_folder[0]) {
    strcpy(target_folder, default_folder);
  } else {
    strcpy(target_folder, MH_DEFAULT_FOLDER);
  }
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!option[j].name[0]) {
	  continue;
	}
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[+folder] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -file	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	      strcpy(spool_file, ptr);
	    } else {
	      print_fatal("Source file does not specified.");
	      exit(1);
	    }
	    f_flag = 1;
	    break;
	  case 2:	/* -width	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	      if ((scan_width = atoi(ptr)) <= 0) {
	        print_fatal("Illegal scan width.");
	        exit(1);
	      }
	    } else {
	      print_fatal("Scan width does not specified.");
	      exit(1);
	    }
	    break;
	  case 3:	/* -truncate	*/
	    r_flag = 1;
	    break;
	  case 4:	/* -notruncate	*/
	    r_flag = 0;
	    break;
	  case 5:	/* -silent	*/
	    s_flag = 1;
	    break;
	  case 6:	/* -nosilent	*/
	    s_flag = 0;
	    break;
	  case 7:	/* -mime	*/
	    mime_mode = 1;
	    break;
	  case 8:	/* -nomime	*/
	    mime_mode = 0;
	    break;
	  case 9:	/* -host	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
#if	defined(POP3) || defined(MSPL)
	      strcpy(pop3_host, ptr);
	      pop3_connect_mode = 1;
#else	/* !(POP3 || MSPL) */
	      print_fatal("Program error.");
	      exit(1);
#endif	/* !(POP3 || MSPL) */
	    } else {
	      print_fatal("Host name does not specified.");
	      exit(1);
	    }
	    break;
	  case 10:	/* -user	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = ptr2;
	    }
	    if (ptr != (char*)NULL) {
	      user = ptr;
	    } else {
	      print_fatal("User name does not specified.");
	      exit(1);
	    }
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    } else if (*ptr) {
      print_fatal("Can't specify message.");
      exit(1);
    }
  }
  if (r_flag < 0) {
    if (f_flag) {
      r_flag = 0;
    } else {
      r_flag = 1;
    }
  }
  if (check_folder(target_folder)) {
    if (yes_or_no("Create folder \"%s\"? ", target_folder)) {
      sprintf(buff, "%s/%s", mh_path, target_folder);
      perm = get_protect(folder_perm);
      if (perm < 0) {
	perm = S_IEXEC | S_IREAD | S_IWRITE;
      }
      if (create_folder(target_folder, perm)) {
        print_fatal("Can't create folder %s.", target_folder);
        exit(1);
      }
    } else {
      exit(1);
    }
  }
  status = 0;
  get_message(target_folder);
  if (message_number) {
    target = message_ptr[message_number - 1] + 1;
  } else {
    target = 1;
  }
  if (user == (char*)NULL) {
    user = (char*)getenv(USER_ENV);
    if (user == (char*)NULL) {
#ifndef	MSDOS
      if (!(passwd = (struct passwd*)getpwuid(geteuid()))) {
	fprintf(stderr, "Can't get password entry.\n");
	exit(1);
      }
      user = passwd->pw_name;
#endif	/* !MSDOS */
      print_fatal("Can't get USER environment.");
      exit(1);
    }
  }
  strcpy(user_name, user);
  if (!f_flag) {
    sprintf(spool_file, "%s/%s", MH_SPOOL_PATH, user_name);
  }
  j = inc_message(spool_file, target_folder, target, r_flag);
  if (j < 0) {
    exit(1);
  }
  if (!j) {
    print_fatal("No mail to incorporate.");
    exit(1);
  }
  if (t_flag) {
    set_context(target_folder, folder_stack);
  }
  if (target) {
    set_current(target_folder, target);
  }
  if (!s_flag) {
    for (i = 0; i < j; i++) {
      if (scan_message(target_folder, target + i, target)) {
	status = 1;
      }
    }
    if (!r_flag) {
      fprintf(stderr, "%s not zero'd\n", spool_file);
    }
  }
  exit(status);
}

#if	defined(POP3) || defined(MSPL)
/*
 * å
 */

static int	inc_message(spool_file, folder_name, number, r_flag)
     char	*spool_file;
     char	*folder_name;
     int	number;
     int	r_flag;
{
  POP3_ERR_CODE	status;
  POP3_RD_STAT	rd_stat;
  FILE		*fp;
  int		count;
  char		buff1[BUFF_SIZE];
  char		buff2[BUFF_SIZE];

  count = 0;
  fp = (FILE*)NULL;
  tcp_init();
  strcpy(mail_spool, spool_file);
  if (pop3_select_server(pop3_host) != POP3_OK) {
    print_fatal("Can't select MSPL/POP3 server.");
    return(-1);
  }
  status = pop3_open();
  if (status != POP3_OK) {
    print_fatal("Can't connect MSPL/POP3 server.");
    return(-1);
  }
  while (status == POP3_OK) {
    status = pop3_read(buff1, sizeof(buff1), &rd_stat);
    switch (rd_stat) {
    case POP3_RD_FROM:
      break;
    case POP3_RD_HEAD:
      if (fp == (FILE*)NULL) {
	if ((!count) &&(!s_flag)) {
	  printf("Incorporating new mail into %s...\n\n", target_folder);
	}
	sprintf(buff2, "%s/%s/%d", mh_path, folder_name, number);
	fp = fopen(buff2, "w");
	if (fp == (FILE*)NULL) {
	  print_fatal("Can't write message %d.", number);
	  status = POP3_ERR_FILE;
	  break;
	}
      }
      /* break  */
    case POP3_RD_SEP:
    case POP3_RD_BODY:
      if (fp != (FILE*)NULL) {
	fputs(buff1, fp);
      } else {
	print_fatal("Program error.");
	status = POP3_ERR_PROG;
      }
      break;
    case POP3_RD_END:
    case POP3_RD_EOF:
      if (fp != (FILE*)NULL) {
	fclose(fp);
	count++;
	number++;
      }
      fp = (FILE*)NULL;
      break;
    default:
      print_fatal("Program error.");
      status = POP3_ERR_PROG;
      break;
    }
    if (rd_stat == POP3_RD_EOF) {
      break;
    }
  }
  if (fp != (FILE*)NULL) {
    fclose(fp);
  }
  if ((status == POP3_OK) && r_flag) {
    pop3_delete();
  }
  pop3_close();
  tcp_exit();
  if (status != POP3_OK) {
    return(-1);
  }
  return(count);
}
#else	/* !(POP3 || MSPL) */
/*
 * å
 */

static int	inc_message(spool_file, folder_name, number, r_flag)
     char	*spool_file;
     char	*folder_name;
     int	number;
     int	r_flag;
{
  FILE	*fp1;
  FILE	*fp2;
  char	buff1[BUFF_SIZE];
  char	buff2[PATH_BUFF];
  int	perm;
  int	status;
  int	count;
  int	format;
  int	sp_flag;

  status = format = 0;
  count = -1;
  fp1 = fopen(spool_file, "r");
  if (fp1 == (FILE*)NULL) {
    return(0);
  }
  while (1) {
    if ((count < 0) || format) {
      if (!fgets(buff1, sizeof(buff1), fp1)) {
        break;
      }
      if (count < 0) {
	count = 0;
	if (!s_flag) {
	  printf("Incorporating new mail into %s...\n\n", target_folder);
	}
      }
    }
    if ((buff1[0] == '\n') || (buff1[0] == '\r')) {
      if (!fgets(buff1, sizeof(buff1), fp1)) {
	break;
      }
    }
    buff2[0] = '\0';
    if (!strncasecmp(buff1, SPOOL_HEADER, sizeof(SPOOL_HEADER) - 1)) {
      format = 0;
      get_real_adrs(buff1 + sizeof(SPOOL_HEADER) - 1, buff2);
    } else if (!strncasecmp(buff1, PACK_HEADER, sizeof(PACK_HEADER) - 1)) {
      format = 1;
    } else {
      print_fatal("Illegal format in spool file.");
      status = 1;
      break;
    }
    strcpy(buff1, buff2);
    sprintf(buff2, "%s/%s/%d", mh_path, folder_name, number);
    fp2 = fopen(buff2, "w");
    if (fp2 != (FILE*)NULL) {
      perm = get_protect(msg_perm);
      if (perm < 0) {
	perm = S_IREAD | S_IWRITE;
      }
      chmod(buff2, perm);
      if (buff1[0]) {
	fprintf(fp2, "%s %s\n", RETURN_FIELD, buff1);
      }
      status = 1;
      if (format) {
	while (fgets(buff1, sizeof(buff1), fp1)) {
	  if (!strncasecmp(buff1, PACK_HEADER, strlen(PACK_HEADER))) {
	    status = 0;
	    break;
	  }
	  fputs(buff1, fp2);
	}
      } else {
	sp_flag = 0;
	while (fgets(buff1, sizeof(buff1), fp1)) {
	  if (!strncasecmp(buff1, SPOOL_HEADER, strlen(SPOOL_HEADER))) {
	    if (!sp_flag) {
	      fputc('>', fp2);
	    } else {
	      status = 0;
	      break;
	    }
	    sp_flag = 0;
	  } else {
	    sp_flag = (buff1[0] == '\n');
	  }
	  fputs(buff1, fp2);
	}
      }
      fclose(fp2);
      count++;
      number++;
      if (status) {
	status = 0;
	break;
      }
    } else {
      print_fatal("Can't create message %d.", number);
      status = 1;
      break;
    }
  }
  fclose(fp1);
  if (!status) {
    if (r_flag) {
#ifndef	DEBUG
#ifdef	SVR4
      if (truncate(spool_file, 0)) {
	print_fatal("Can't truncate spool file.");
      }
#else	/* !SVR4 */
      fp1 = fopen(spool_file, "w");
      if (fp1 != (FILE*)NULL) {
	fclose(fp1);
      } else {
	print_fatal("Can't truncate spool file.");
      }
#endif	/* !SVR4 */
#endif	/* !DEBUG */
    }
  }
  return(count);
}
#endif	/* !(POP3 || MSPL) */
