/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Field manage routine
 *  File        : mmh_fild.c
 *  Version     : 2.19
 *  First Edit  : 1994-06/22
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"
#include	"kanjilib.h"
#include	"mimelib.h"

char	*month_string[] = {		/* ̾			*/
  "???", "Jan", "Feb", "Mar", "Apr", "May", "Jun",
  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};
char	*day_string[] = {		/* ̾		*/
  "???", "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};

int	jst_mode = 1;			/* JST ⡼		*/
int	x_nsubj_mode = 1;		/* X-Nsubject ⡼	*/
int	mime_mode = 1;			/* MIME ⡼		*/
int	default_code = EUC_CODE;	/* ǥեȴ	*/
int	scan_width = DEFAULT_WIDTH;	/* ǥեȤν	*/

/*
 * ¥ɥ쥹
 */

#ifdef	__STDC__
char	*get_real_adrs(char *str1, char *str2)
#else	/* !__STDC__ */
char	*get_real_adrs(str1, str2)
     char	*str1;
     char	*str2;
#endif	/* !__STDC__ */
{
  int	status;
  char	*ptr1, *ptr2;
  char	quote;

  /*
   * νϲäΤǻפ񤭴ޤ
   */

  ptr1 = ptr2 = str1;
  quote = '\0';
  status = 1;
  while (status) {
    if (*ptr1 == 0x1b) {	/* ץ󥹤ִ */
      *ptr1++ = ' ';
      while (*ptr1) {
	if ((*ptr1 < 0x30) || (*ptr1 > 0x7e)) {
	  *ptr1++ = ' ';
	} else {
	  *ptr1++ = ' ';
	  break;
	}
      }
    } else if (quote) {
      if (*ptr1) {
	if (*ptr1++ == quote) {
	  quote = '\0';
	}
      } else {
	quote = '\0';
	print_warning("Unmatched quote found in mail address.");
      }
    } else {
      switch (*ptr1) {
      case '(':
	ptr1++;
	status = 1;
	while (status) {
	  if (!(*ptr1)) {
	    break;
	  }
	  switch (*ptr1++) {
	  case '(':
	    status++;
	    break;
	  case ')':
	    status--;
	    break;
	  default:
	    break;
	  }
	}
#ifdef	notdef
	if (status) {
	  print_warning("Unexpected bracket found in mail address.");
	}
#endif	/* notdef */
	status = 1;
	break;
      case '<':
	ptr2 = ++ptr1;
	while ((*ptr2 == ' ') || (*ptr2 == '\t')) {
	  ptr2++;
	}
	status = 1;
	while (*ptr1) {
	  if (*ptr1++ == '>') {
	    break;
	  }
	}
	status = 0;
	break;
      case '\"':
	quote = *ptr1++;
	break;
      case ',':
      case '\n':
      case '\0':
	ptr2 = str1;
	status = 0;
	break;
      default:
	ptr1++;
	break;
      }
    }
  }
  while (*ptr2 && (*ptr2 != ',') && (*ptr2 != ' ') && (*ptr2 != '\t')
	 && (*ptr2 != '\n') && (*ptr2 != '>') && (*ptr2 != '(')) {
    *str2++ = *ptr2++;
  }
  *str2 = '\0';
  while ((*ptr1 == ',') || (*ptr1 == ' ') || (*ptr1 == '\t')
	 || (*ptr1 == '\n')) {
    *ptr1++ = '\0';
  }
  return(ptr1);
}

/*
 * åɽ
 */

#ifdef	__STDC__
int	scan_message(char *folder_name, int number, int current)
#else	/* !__STDC__ */
int	scan_message(folder_name, number, current)
     char	*folder_name;
     int	number;
     int	current;
#endif	/* !__STDC__ */
{
  FILE			*fp;
  char			buff[PATH_BUFF];

  sprintf(buff, "%s/%s/%d", mh_path, folder_name, number);
  fp = fopen(buff, "r");
  if (fp == (FILE*)NULL) {
    return(1);
  }
  scan_fp(fp, number, current);
  fclose(fp);
  return(0);
}

/*
 * եɽ
 */

#ifdef	__STDC__
int	scan_fp(FILE *fp, int number, int current)
#else	/* !__STDC__ */
int	scan_fp(fp, number, current)
     FILE	*fp;
     int	number;
     int	current;
#endif	/* !__STDC__ */
{
  char			*ptr1, *ptr2;
  char			buff[BUFF_SIZE];
  static char		from_buff[BUFF_SIZE];
  static char		to_buff[BUFF_SIZE];
  static char		date_buff[BUFF_SIZE];
  static char		subject_buff[BUFF_SIZE];
  static char		x_nsubj_buff[BUFF_SIZE];
  static char		mh_reply_buff[SMALL_BUFF];
  static struct cpy_hdr	scan_fields[] = {
    {FROM_FIELD,	from_buff,	sizeof(from_buff)},
    {TO_FIELD,		to_buff,	sizeof(to_buff)},
    {DATE_FIELD,	date_buff,	sizeof(date_buff)},
    {SUBJECT_FIELD,	subject_buff,	sizeof(subject_buff)},
    {X_NSUBJ_FIELD,	x_nsubj_buff,	sizeof(x_nsubj_buff)},
    {MH_REPLY_FIELD,	mh_reply_buff,	sizeof(mh_reply_buff)},
  };
  short			year, month, date, day, hour, minute, second;
  int			width;
  int			first, skip;

  width = scan_width;
  copy_mmh_fields(fp, scan_fields,
		  sizeof(scan_fields) / sizeof(struct cpy_hdr));
  if ((!from_buff[0]) && (to_buff[0])) {
    sprintf(from_buff, "To:%s", to_buff);
  }
#ifdef	notdef
#ifdef	MIME
  if (mime_mode) {
    mime_decode(from_buff, buff);
  } else {
    strcpy(buff, from_buff);
  }
#else	/* !MIME */
  strcpy(buff, from_buff);
#endif	/* !MIME */
#else	/* !notdef */
  get_real_adrs(from_buff, buff);
#endif	/* !notdef */
#ifdef	MSDOS
  to_sjis(from_buff, buff, default_code);
  sjis_strncpy2(buff, from_buff, 13);
#else	/* !MSDOS */
  to_euc(from_buff, buff, default_code);
  euc_strncpy2(buff, from_buff, 13);
#endif	/* !MSDOS */
  strcpy(from_buff, buff);

#ifdef	MIME
  if (mime_mode) {
    mime_decode(subject_buff, buff);
#ifdef	MSDOS
    to_sjis(subject_buff, buff, default_code);
#else	/* !MSDOS */
    to_euc(subject_buff, buff, default_code);
#endif	/* !MSDOS */
  } else {
#ifdef	MSDOS
    to_sjis(buff, subject_buff, default_code);
#else	/* !MSDOS */
    to_euc(buff, subject_buff, default_code);
#endif	/* !MSDOS */
    strcpy(subject_buff, buff);
  }
#else	/* !MIME */
#ifdef	MSDOS
  to_sjis(buff, subject_buff, default_code);
#else	/* !MSDOS */
  to_euc(buff, subject_buff, default_code);
#endif	/* !MSDOS */
  strcpy(subject_buff, buff);
#endif	/* !MIME */
  convert_date(date_buff, &year, &month, &date, &day, &hour,
	       &minute, &second, buff);
  sprintf(date_buff, "%4d%c%c%02d/%02d %s ", number,
	  (number == current) ? '+' : ' ',
	  mh_reply_buff[0] ? '-' : ' ',
	  month, date, from_buff);
  width -= strlen(date_buff);
  if (x_nsubj_buff[0] && x_nsubj_mode) {
    recover_jis(buff, x_nsubj_buff);
#ifdef	MSDOS
    to_sjis(subject_buff, buff, default_code);
#else	/* !MSDOS */
    to_euc(subject_buff, buff, default_code);
#endif	/* !MSDOS */
  }
#ifdef	MSDOS
  sjis_tab_strncpy(buff, subject_buff, width);
#else	/* !MSDOS */
  euc_tab_strncpy(buff, subject_buff, width);
#endif	/* !MSDOS */
  strcpy(subject_buff, buff);
  ptr1 = subject_buff;
  while (*ptr1) {
    if (*ptr1 == '\t') {
      *ptr1 = ' ';
    }
    width--;
    ptr1++;
  }
  if (width > 2) {
    strcat(ptr1, " <<");
    ptr1 += 3;
    width -= 3;
    while (width > 0) {
      first = 1;
      if (!fgets(buff, sizeof(buff), fp)) {
	break;
      }
#ifdef	MSDOS
      to_sjis(x_nsubj_buff, buff, default_code);
#else	/* !MSDOS */
      to_euc(x_nsubj_buff, buff, default_code);
#endif	/* !MSDOS */
      ptr2 = x_nsubj_buff;
      skip = 0;
      while ((*ptr2 == ' ') || (*ptr2 == '\t')) {
	ptr2++;
	skip = 1;
      }
      while (width > 0) {
	if (*ptr2 < ' ') {
	  break;
	}
	if (*ptr2 == '\t') {
	  *ptr1++ = ' ';
	  width--;
	} else if (*ptr2 & 0x80) {
	  width -= 2;
	  if (width >= 0) {
	    *ptr1++ = *ptr2++;
	    *ptr1++ = *ptr2++;
	  }
	} else {
	  if (skip) {
	    skip = 0;
	    if (first) {
	      *ptr1++ = *ptr2++;
	      first = 0;
	    } else {
	      *ptr1++ = ' ';
	    }
	  } else {
	    *ptr1++ = *ptr2++;
	  }
	  width--;
	}
      }
      *ptr1 = '\0';
    }
  }
  printf("%s%s\n", date_buff, subject_buff);
  return(0);
}

/*
 * եեޥåѴ
 */

#ifdef	__STDC__
void	convert_date(char *dates, short *year, short *month, short *date,
		     short *day, short *hour, short *minute, short *second,
		     char *zone_name)
#else	/* !__STDC__ */
void	convert_date(dates, year, month, date, day,
		     hour, minute, second, zone_name)
     char	*dates;
     short	*year;
     short	*month;
     short	*date;
     short	*day;
     short	*hour;
     short	*minute;
     short	*second;
     char	*zone_name;
#endif	/* !__STDC__ */
{
  register short	i;
  int			offset;
  int			jst_flag;

  *year   = 0;
  *month  = 0;
  *date   = 0;
  *day    = 0;
  *hour   = 0;
  *minute = 0;
  *second = 0;

  while ((*dates == ' ') || (*dates == '\t')) {
    dates++;
  }
  if (!*dates) {
    return;
  }
  for (i = 0; i < sizeof(day_string) / sizeof(char*); i++) {
    if (!strncasecmp(dates, day_string[i], 3)) {
      *day = i;
      i = -1;
      break;
    }
  }
  if (i < 0) {
    dates = next_param(dates);
  }
  for (i = 0; i < sizeof(month_string) / sizeof(char*); i++) {
    if (!strncasecmp(dates, month_string[i], 3)) {
      *month = i;		/* 	*/
      i = -1;
      break;
    }
  }
  if (i < 0) {			/* (Date,) Month Day Time Year Zone */	
    dates = next_param(dates);
    *date = atoi(dates);	/* 	*/
    while (*dates) {
      if (*dates++ == ' ') {
	break;
      }
    }
    *hour = atoi(dates);	/* 	*/
    while (*dates) {
      if (*dates++ == ':') {
	break;
      }
    }
    *minute = atoi(dates);	/* ʬ	*/
    while (isdigit(*dates)) {
      dates++;
    }
    if (*dates == ':') {
      dates++;
      *second = atoi(dates);	/* 	*/
    }
    dates = next_param(dates);
    *year = atoi(dates);	/* ǯ	*/
    if ((*year > 0) && (*year < 1000)) {
      *year += 1900;
    }
    dates = next_param(dates);
  } else {			/* Date, Day Month Year Time Zone */
    *date = atoi(dates);	/* 	*/
    dates = next_param(dates);
    for (i = 0; i < sizeof(month_string) / sizeof(char*); i++) {
      if (!strncasecmp(dates, month_string[i], 3)) {
	*month = i;		/* 	*/
	break;
      }
    }
    dates = next_param(dates);
    *year = atoi(dates);	/* ǯ	*/
    if ((*year > 0) && (*year < 100)) {
      *year += 1900;
    }
    dates = next_param(dates);
    *hour = atoi(dates);	/* 	*/
    while (*dates) {
      if (*dates++ == ':') {
	break;
      }
    }
    *minute = atoi(dates);	/* ʬ	*/
    while (isdigit(*dates)) {
      dates++;
    }
    if (*dates == ':') {
      dates++;
      *second = atoi(dates);	/* 	*/
    }
    dates = next_param(dates);
  }
  strcpy(zone_name, dates);
  jst_flag = 0;
  if (!strncmp(dates, "GMT", 3)) {
    dates += 3;
  }
  if (*dates == '+') {
    dates++;
    offset = atoi(dates);
    if (jst_mode) {
      *hour   -= offset / 100;
      *minute -= offset % 100;
    }
    jst_flag = 1;
  } else if (*dates == '-') {
    dates++;
    offset = atoi(dates);
    if (jst_mode) {
      *hour   += offset / 100;
      *minute += offset % 100;
    }
    jst_flag = 1;
  } else if (*dates < ' ') {
    jst_flag = 1;
  }
  if (jst_flag) {
    strcpy(zone_name, "JST");
    gmt_to_jst(year, month, date, day, hour, minute, second);
  }
  dates = zone_name;
  while (*dates) {
    if (*dates == '\n') {
      *dates = '\0';
    }
    dates++;
  }
}

/*
 * GMT ֤ JST Ѵ
 */

#ifdef	__STDC__
int	gmt_to_jst(short *year, short *month, short *date, short *day,
		   short *hour, short *minute, short *second)
#else	/* !__STDC__ */
int	gmt_to_jst(year, month, date, day, hour, minute, second)
     short	*year;
     short	*month;
     short	*date;
     short	*day;
     short	*hour;
     short	*minute;
     short	*second;
#endif	/* !__STDC__ */
{
  struct tm	*t1;
  time_t	gmt_time, date_time;
  int		i;
  
  if (!jst_mode) {
    return(0);
  }
  i = (*year - 1) / 4 - 492;
  date_time = 60L * 60L * 24L;
  gmt_time = (*year - 1970) * (date_time * 365L) + i * date_time;
  for (i = 1; i < *month; i++) {
    switch (i) {
    case 1:
    case 3:
    case 5:
    case 7:
    case 8:
    case 10:
    case 12:
      gmt_time += 31L * (60L * 60L * 24L);
      break;
    case 2:
      if ((((*year % 4) == 0) && (*year % 100)) || ((*year % 400) == 0)) {
	gmt_time += 29L * date_time;
      } else {
	gmt_time += 28L * date_time;
      }
      break;
    case 4:
    case 6:
    case 9:
    case 11:
      gmt_time += 30L * date_time;
      break;
    default:
      print_fatal("Illegal GMT time.");
      break;
    }
  }
  gmt_time += (*date - 1) * date_time + *hour * (60L * 60L)
    + *minute * 60 + *second;
  t1 = localtime(&gmt_time);
  if (t1 != (struct tm*)NULL) {
    *year = t1->tm_year + 1900;
    *month = t1->tm_mon + 1;
    *date = t1->tm_mday;
    *hour = t1->tm_hour;
    *minute = t1->tm_min;
    *second = t1->tm_sec;
    *day = t1->tm_wday + 1;
  }
  return(1);
}

/*
 * Υѥ᡼
 */

#ifdef	__STDC__
char	*next_param(char *ptr)
#else	/* !__STDC__ */
char	*next_param(ptr)
     char	*ptr;
#endif	/* !__STDC__ */
{
  while (*ptr) {
    if ((*ptr == ' ') || (*ptr =='\t')) {
      while ((*ptr == ' ') || (*ptr =='\t')) {
	ptr++;
      }
      break;
    }
    ptr++;
  }
  return(ptr);
}

/*
 * ESC  JIS ʸ
 */

#ifdef	__STDC__
void	recover_jis(char *ptr1, char *ptr2)
#else	/* !__STDC__ */
void	recover_jis(ptr1, ptr2)
     char	*ptr1;
     char	*ptr2;
#endif	/* !__STDC__ */
{
  char			*ptr3;
  char			*ptr4;
  register CHARSET	charset = ROMAN_CHAR;

  if ((ptr1 == (char*)NULL) || (ptr2 == (char*)NULL)) {
    return;
  }
  ptr3 = ptr1;
  ptr4 = ptr2;
  while (*ptr2) {
    if (charset &&
	((!strncmp(ptr2, DJIS_OUT1, 2)) || (!strncmp(ptr2, DJIS_OUT2, 2)))) {
      strcpy(ptr1, jis_out);
      charset = ROMAN_CHAR;
      ptr1 += jis_out_len;
      ptr2 += 2;
      continue;
    } else if ((charset != KANJI_CHAR) &&
	       ((!strncmp(ptr2, DJIS_IN1, 2))
		|| (!strncmp(ptr2, DJIS_IN2, 2)))) {
      charset = KANJI_CHAR;
      strcpy(ptr1, jis_in);
      ptr1 += jis_in_len;
      ptr2 += 2;
    } else if ((charset != KANJI_CHAR) && (!strncmp(ptr2, DJIS_IN3, 3))) {
      charset = KANJI_CHAR;
      strcpy(ptr1, jis_in);
      ptr1 += jis_in_len;
      ptr2 += 3;
#ifdef	SUPPORT_X0201
    } else if ((charset != KANA_CHAR) && (!strncmp(ptr2, DJIS_X0201, 2))) {
      charset = KANA_CHAR;
      strcpy(ptr1, JIS_X0201);
      ptr1 += 3;
      ptr2 += 2;
#endif	/* SUPPORT_X0201 */
    } else if ((charset != HOJO_CHAR) && (!strncmp(ptr2, DJIS_X0212, 3))) {
      charset = HOJO_CHAR;
      strcpy(ptr1, JIS_X0212);
      ptr1 += 4;
      ptr2 += 3;
    } else if (*ptr2 == ESC_CODE) {
      strcpy(ptr3, ptr4);
      return;
    } else {
      switch (charset) {
      case KANJI_CHAR:
      case HOJO_CHAR:
	*ptr1++ = *ptr2++;
	*ptr1++ = *ptr2++;
	break;
      case ROMAN_CHAR:
      case KANA_CHAR:
      default:
	*ptr1++ = *ptr2++;
	break;
      }
    }
  }
  if (charset) {
    strcpy(ptr1, jis_out);
  } else {
    *ptr1 = '\0';
  }
}

/*
 * եեޥåѴ
 */

#ifdef	__STDC__
void	convert_article_date(char *dates, short *year, short *month,
			     short *date, short *day, short *hour,
			     short *minute, short *second, char *zone_name)
#else	/* !__STDC__ */
void	convert_article_date(dates, year, month, date, day,
			     hour, minute, second, zone_name)
     char	*dates;
     short	*year;
     short	*month;
     short	*date;
     short	*day;
     short	*hour;
     short	*minute;
     short	*second;
     char	*zone_name;
#endif	/* !__STDC__ */
{
  register short	i;
  int			offset;
  int			jst_flag;

  *year   = 0;
  *month  = 0;
  *date   = 0;
  *day    = 0;
  *hour   = 0;
  *minute = 0;
  *second = 0;

  while ((*dates == ' ') || (*dates == '\t')) {
    dates++;
  }
  if (!*dates) {
    return;
  }
  for (i = 0; i < sizeof(day_string) / sizeof(char*); i++) {
    if (!strncasecmp(dates, day_string[i], 3)) {
      *day = i;
      i = -1;
      break;
    }
  }
  if (i < 0) {
    dates = next_param(dates);
  }
  for (i = 0; i < sizeof(month_string) / sizeof(char*); i++) {
    if (!strncasecmp(dates, month_string[i], 3)) {
      *month = i;		/* 	*/
      i = -1;
      break;
    }
  }
  if (i < 0) {			/* (Date,) Month Day Time Year Zone */	
    dates = next_param(dates);
    *date = atoi(dates);	/* 	*/
    while (*dates) {
      if (*dates++ == ' ') {
	break;
      }
    }
    *hour = atoi(dates);	/* 	*/
    while (*dates) {
      if (*dates++ == ':') {
	break;
      }
    }
    *minute = atoi(dates);	/* ʬ	*/
    while (isdigit(*dates)) {
      dates++;
    }
    if (*dates == ':') {
      dates++;
      *second = atoi(dates);	/* 	*/
    }
    dates = next_param(dates);
    *year = atoi(dates);	/* ǯ	*/
    if ((*year > 0) && (*year < 1000)) {
      *year += 1900;
    }
    dates = next_param(dates);
  } else {			/* Date, Day Month Year Time Zone */
    *date = atoi(dates);	/* 	*/
    dates = next_param(dates);
    for (i = 0; i < sizeof(month_string) / sizeof(char*); i++) {
      if (!strncasecmp(dates, month_string[i], 3)) {
	*month = i;		/* 	*/
	break;
      }
    }
    dates = next_param(dates);
    *year = atoi(dates);	/* ǯ	*/
    if ((*year > 0) && (*year < 100)) {
      *year += 1900;
    }
    dates = next_param(dates);
    *hour = atoi(dates);	/* 	*/
    while (*dates) {
      if (*dates++ == ':') {
	break;
      }
    }
    *minute = atoi(dates);	/* ʬ	*/
    while (isdigit(*dates)) {
      dates++;
    }
    if (*dates == ':') {
      dates++;
      *second = atoi(dates);	/* 	*/
    }
    dates = next_param(dates);
  }
  strcpy(zone_name, dates);
  jst_flag = 0;
  if (!strncmp(dates, "GMT", 3)) {
    dates += 3;
  }
  if (*dates == '+') {
    dates++;
    offset = atoi(dates);
    if (jst_mode) {
      *hour   -= offset / 100;
      *minute -= offset % 100;
    }
    jst_flag = 1;
  } else if (*dates == '-') {
    dates++;
    offset = atoi(dates);
    if (jst_mode) {
      *hour   += offset / 100;
      *minute += offset % 100;
    }
    jst_flag = 1;
  } else if (*dates < ' ') {
    jst_flag = 1;
  }
  if (jst_flag) {
    strcpy(zone_name, "JST");
    gmt_to_jst(year, month, date, day, hour, minute, second);
  }
  dates = zone_name;
  while (*dates) {
    if (*dates == '\n') {
      *dates = '\0';
    }
    dates++;
  }
}
