/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Remove folder command
 *  File        : rmf.c
 *  Version     : 2.19
 *  First Edit  : 1994-06/18
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
  {"interactive",	0},
  {"nointeractive",	0},
};
static char		rmf_opt[SMALL_BUFF];
static char		default_folder[SMALL_BUFF];
static struct cpy_hdr	rmf_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {MH_DEFAULT_FIELD,	default_folder,	sizeof(default_folder)},
  {"rmfopt:",		rmf_opt,	sizeof(rmf_opt)},
};

static int	remove_folder();	/* ե	*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  int		i, j;
  int		i_flag = 1;
  int		t_flag = 0;
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(rmf_option, sizeof(rmf_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }

  /*
   * åβ
   */

  ptr2 = rmf_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[+folder] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -interactive	*/
	    i_flag = 1;
	    break;
	  case 2:	/* -nointeractive */
	    i_flag = 0;
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    } else if (*ptr) {
      print_fatal("Can't specify message.");
      exit(1);
    }
  }
  if (check_folder(target_folder)) {
    print_fatal("Folder %s does not exist.", target_folder);
    exit(1);
  }
  if (i_flag && (!yes_or_no("Remove folder %s? ", target_folder))) {
    exit(1);
  } else {
    if (remove_folder(target_folder)) {
      print_fatal("Can't remove folder %s.", target_folder);
      exit(1);
    }
  }
  ptr = ptr2 = target_folder;
  while (*ptr) {
    if (*ptr == '/') {
      ptr2 = ptr++;
    } else {
      ptr += check_char((unsigned char*)ptr);
    }
  }
  *ptr2 = '\0';
  if (!*target_folder) {
    if (default_folder[0]) {
      strcpy(target_folder, default_folder);
    } else {
      strcpy(target_folder, MH_DEFAULT_FOLDER);
    }
  }
  set_context(target_folder, folder_stack);
  printf("[+%s now current]\n", target_folder);
  exit(0);
}

/*
 * ե
 */

static int	remove_folder(folder_name)
     char	*folder_name;
{
#ifdef	HAVE_FILES
  FILES_STRUCT	dp;
#else	/* !HAVE_FILES */
  DIR_PTR	*dp;
  DIR		*dir_ptr;
#endif	/* !HAVE_FILES */
  char		buff[PATH_BUFF];
  char		*ptr;
  int		status;

  sprintf(buff, "%s/%s", mh_path, folder_name);
  ptr = buff;
  while (*ptr) {
    ptr++;
  }
  status = 0;
#ifdef	HAVE_FILES
  strcat(ptr, "/*.*");
  if (!dos_files(buff, &dp, FILE_ATTR)) {
    do {
#ifdef	__TURBOC__
      strcpy(ptr + 1, dp.ff_name);
#else	/* !__TURBOC__ */
      strcpy(ptr + 1, dp.name);
#endif	/* !__TURBOC__ */
      if (unlink(buff)) {
        print_fatal("Can't remove \"%s\".", ptr + 1);
        status = 1;
      }
    } while (!dos_nfiles(&dp));
  }
#else	/* !HAVE_FILES */
  dir_ptr = opendir(buff);
  if (dir_ptr != (DIR*)NULL) {
    *ptr = '/';
    while (1) {
      dp = readdir(dir_ptr);
      if (dp == (DIR_PTR*)NULL) {
	break;
      }
      if ((dp->d_name[0] == '.') &&
	  ((dp->d_name[1] == '.') || (dp->d_name[1] == '\0'))) {
	continue;
      }
      strcpy(ptr + 1, dp->d_name);
      if (unlink(buff)) {
        print_fatal("Can't remove \"%s\".", dp->d_name);
        status = 1;
      }
    }
    closedir(dir_ptr);
  }
#endif	/* !HAVE_FILES */
  *ptr = '\0';
  if (!status) {
    status = rmdir(buff);
  }
  return(status);
}
