/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Scan message command
 *  File        : scan.c
 *  Version     : 2.19
 *  First Edit  : 1994-05/29
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"
#include	"kanjilib.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",	0},
  {"reverse",	0},
  {"noreverse",	0},
  {"width",	NUMBER_MASK},
  {"file",	FILE_MASK},
#ifdef	MIME
  {"mime",	0},
  {"nomime",	0},
#endif	/* MIME */
};
static char		scan_opt[SMALL_BUFF];
static struct cpy_hdr	scan_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {"scanopt",		scan_opt,	sizeof(scan_opt)},
};
static char		tmp_file[PATH_BUFF] = "";

static int	scan_file();		/* եɽ	*/
static void	force_exit();		/* λ		*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  int		status;
  int		current;
  int		i, j;
  int		t_flag = 0;
  int		r_flag = 0;
  char		spool_file[PATH_BUFF];
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(scan_option, sizeof(scan_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }

  spool_file[0] = '\0';

  /*
   * åβ
   */

  ptr2 = scan_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[+folder] [msg] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  case 1:	/* -reverse	*/
	    r_flag = 1;
	    break;
	  case 2:	/* -noreverse	*/
	    r_flag = 0;
	    break;
	  case 3:	/* -width	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	      if ((scan_width = atoi(ptr)) <= 0) {
	        print_fatal("Illegal scan width.");
	        exit(1);
	      }
	    } else {
	      print_fatal("Scan width does not specified.");
	      exit(1);
	    }
	    break;
	  case 4:	/* -file	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr != (char*)NULL) {
	      strcpy(spool_file, ptr);
	    } else {
	      print_fatal("Scan file does not specified.");
	      exit(1);
	    }
	    break;
#ifdef	MIME
	  case 5:	/* -mime	*/
	    mime_mode = 1;
	    break;
	  case 6:	/* -nomime	*/
	    mime_mode = 0;
	    break;
#endif	/* MIME */
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  if (spool_file[0]) {
    exit(scan_file(spool_file));
  }
  get_message(target_folder);
  current = get_current(target_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  if (option[j].mode) {
	    i++;
	  }
	  break;
	}
      }
    } else if (*ptr != '+') {
      if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (check_folder(target_folder)) {
    print_fatal("Folder %s does not exist.", target_folder);
    exit(1);
  }
  status = 0;
  if (!target_number) {
    target_number = message_number;
    target_ptr = message_ptr;
  }
  if (!target_number) {
    print_fatal("No messages in %s.", target_folder);
    exit(1);
  }
  qsort(target_ptr, target_number, sizeof(int), int_compare);
  if (t_flag) {
    set_context(target_folder, folder_stack);
  }
  if (r_flag) {
    for (i = target_number - 1; i >= 0; i--) {
      if (scan_message(target_folder, target_ptr[i], current)) {
        status = 1;
      }
    }
  } else {
    for (i = 0; i < target_number; i++) {
      if (scan_message(target_folder, target_ptr[i], current)) {
        status = 1;
      }
    }
  }
  exit(status);
}

/*
 * եɽ
 */

static int	scan_file(spool_file)
     char	*spool_file;
{
  FILE	*fp1;
  FILE	*fp2;
  char	buff1[BUFF_SIZE];
  char	buff2[PATH_BUFF];
  int	status;
  int	count;
  int	format;
  int	number;

  count = status = format = 0;
  number = 1;
  fp1 = fopen(spool_file, "r");
  if (fp1 == (FILE*)NULL) {
    print_fatal("Can't open spool file.");
    return(1);
  }
  while (1) {
    if ((!count) || format) {
      if (!fgets(buff1, sizeof(buff1), fp1)) {
        break;
      }
    }
    if ((buff1[0] == '\n') || (buff1[0] == '\r')) {
      if (!fgets(buff1, sizeof(buff1), fp1)) {
	break;
      }
    }
    if (!strncasecmp(buff1, SPOOL_HEADER, sizeof(SPOOL_HEADER) - 1)) {
      format = 0;
    } else if (!strncasecmp(buff1, PACK_HEADER, sizeof(PACK_HEADER) - 1)) {
      format = 1;
    } else {
      print_fatal("Illegal format in spool file.");
      status = 1;
      break;
    }
    sprintf(buff2, "%s/mmh%05d.%03d", tmp_dir, number, getpid() % 100);
    signal(SIGTERM, force_exit);
    strcpy(tmp_file, buff2);
    fp2 = fopen(buff2, "w");
    if (fp2 != (FILE*)NULL) {
      chmod(buff2, S_IREAD | S_IWRITE);
      status = 1;
      if (format) {
	while (fgets(buff1, sizeof(buff1), fp1)) {
	  if (!strncasecmp(buff1, PACK_HEADER, strlen(PACK_HEADER))) {
	    status = 0;
	    break;
	  }
	  fputs(buff1, fp2);
	}
      } else {
	while (fgets(buff1, sizeof(buff1), fp1)) {
	  if (!strncasecmp(buff1, SPOOL_HEADER, strlen(SPOOL_HEADER))) {
	    status = 0;
	    break;
	  }
	  fputs(buff1, fp2);
	}
      }
      fclose(fp2);
      fp2 = fopen(buff2, "r");
      if (fp2 != (FILE*)NULL) {
	scan_fp(fp2, number, 0);
	fclose(fp2);
	number++;
      } else {
	print_fatal("Can't read temporary file.");
	status = 1;
      }
      count++;
      unlink(buff2);
      if (status) {
	status = 0;
	break;
      }
    } else {
      print_fatal("Can't write temporary file.");
      status = 1;
      break;
    }
  }
  fclose(fp1);
  return(status);
}

/*
 * λ
 */

static void	force_exit()
{
  if (tmp_file[0]) {
    unlink(tmp_file);
  }
  exit(1);
}
