/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Show message command
 *  File        : show.c
 *  Version     : 2.19
 *  First Edit  : 1994-05/24
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"
#include	"kanjilib.h"
#include	"mimelib.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",	0},
  {"all",	0},
  {"noall",	0},
  {"showproc",	PROCESS_MASK},
#ifdef	MIME
  {"mime",	0},
  {"nomime",	0},
#endif	/* MIME */
};
static char		show_proc[PATH_BUFF];
static char		show_opt[SMALL_BUFF];
static struct cpy_hdr	show_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {"showproc:",		show_proc,	sizeof(show_proc)},
  {"showopt:",		show_opt,	sizeof(show_opt)},
};
static char		tmp_file[PATH_BUFF] = "";

/*
 * ɽإå
 */

static char	*print_field[] = {
  X_NSUBJ_FIELD,		/* ΥեɤƬˤ뤳!	*/
  DATE_FIELD,			/* Υեɤ 2 ܤˤ뤳!	*/
  FROM_FIELD,
  TO_FIELD,
  APP_TO_FIELD,
  CC_FIELD,
  BCC_FIELD,
  REPLY_FIELD,
  IN_REPLY_FIELD,
  SUBJECT_FIELD,
  GROUP_FIELD,
  FOLLOWUP_FIELD,
  DIST_FIELD,
  ORGAN_FIELD,
};
static int	show_message();		/* åɽ	*/
static int	convert_code();		/* Ѵ		*/
static void	force_exit();		/* λ		*/

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  int		status;
  int		current;
  int		i, j;
  int		a_flag = 0;
  int		e_flag = 0;
  int		t_flag = 0;
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }
  if (!strncasecmp(prog_name, PREV_COMMAND, sizeof(PREV_COMMAND) - 1)) {
    e_flag = -1;
  } else if (!strncasecmp(prog_name, NEXT_COMMAND, sizeof(NEXT_COMMAND) - 1)) {
    e_flag = 1;
  }

  /*
   * ե졼
   */

  if (get_environ(show_option, sizeof(show_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }
#ifdef	DEBUG
  printf("showproc=%s\n", show_proc);
#endif	/* DEBUG */

  /*
   * åβ
   */

  ptr2 = show_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    if (e_flag) {
	      usage(prog_name, "[+folder] [switches]",
		    option, sizeof(option) / sizeof(struct option));
	    } else {
	      usage(prog_name, "[+folder] [msg] [switches]",
		    option, sizeof(option) / sizeof(struct option));
	    }
	    exit(0);
	    break;
	  case 1:	/* -all		*/
	    a_flag = 1;
	    break;
	  case 2:	/* -noall	*/
	    a_flag = 0;
	    break;
	  case 3:	/* -showproc	*/
	    ptr = (char*)NULL;
	    if (i > 0) {
	      if (++i < argc) {
		ptr = argv[i];
	      }
	    } else if (*ptr2) {
	      ptr = get_opt_param(&ptr2);
	    }
	    if (ptr) {
	      strcpy(show_proc, ptr);
	    } else {
	      print_fatal("Show proc does not specified.");
	      exit(1);
	    }
	    break;
#ifdef	MIME
	  case 4:	/* -mime	*/
	    mime_mode = 1;
	    break;
	  case 5:	/* -nomime	*/
	    mime_mode = 0;
	    break;
#endif	/* MIME */
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  get_message(target_folder);
  current = get_current(target_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  if (option[j].mode) {
	    i++;
	  }
	  break;
	}
      }
    } else if (*ptr != '+') {
      if (e_flag) {
	print_fatal("Can't specify message.");
	exit(1);
      }
      if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (check_folder(target_folder)) {
    print_fatal("Folder %s does not exist.", target_folder);
    exit(1);
  }
  status = 0;
  if ((!target_number) || e_flag) {
    if (current <= 0) {
      print_fatal("Can't get current message.");
      exit(1);
    }
    if (e_flag < 0) {
      if (add_list(MH_PREV_PARAM, current)) {
	exit(1);
      }
    } else if (e_flag > 0) {
      if (add_list(MH_NEXT_PARAM, current)) {
	exit(1);
      }
    } else {
      if (add_list(MH_CUR_PARAM, current)) {
	exit(1);
      }
    }
  }
  if (!target_number) {
    print_fatal("No messages in %s.", target_folder);
    exit(1);
  }
  qsort(target_ptr, target_number, sizeof(int), int_compare);
  for (i = 0; i < target_number; i++) {
    if (show_message(target_folder, target_ptr[i], a_flag + 1)) {
      status = 1;
    }
  }
  if (t_flag) {
    set_context(target_folder, folder_stack);
  }
  set_current(target_folder, target_ptr[target_number - 1]);
  exit(status);
}

/*
 * åɽ
 */

static int	show_message(folder_name, number, mode)
     char	*folder_name;
     int	number;
     int	mode;
{
  char	buff1[BUFF_SIZE];
  char	buff2[BUFF_SIZE];
  char	*ptr, *ptr2;
#ifdef	MSDOS
  char	*argv[8];
  int	i;
#endif	/* MSDOS */
  int	status;

  sprintf(buff1, "%s/%s/%d", mh_path, folder_name, number);
  sprintf(buff2, "%s/mmh%05d.%03d", tmp_dir, number, getpid() % 100);
  convert_code(buff1, buff2, mode);

  ptr = buff1;
#ifndef	MSDOS
  strcpy(ptr, "exec ");
  while (*ptr) {
    ptr++;
  }
#endif	/* !MSDOS */
  if (show_proc[0]) {
    sprintf(ptr, "%s %s", show_proc, buff2);
  } else {
    ptr2 = (char*)getenv(PAGER_ENV);
    if (ptr2 != (char*)NULL) {
      sprintf(ptr, "%s %s", ptr2, buff2);
    } else {
      sprintf(ptr, "%s %s", MH_DEFAULT_PAGER, buff2);
    }
  }
  fprintf(stderr, "(Message %s:%d)\n", folder_name, number);
#ifdef	MSDOS
  ptr = buff1;
  i = 0;
  while (*ptr) {
    argv[i++] = ptr;
    while (*ptr) {
      if ((*ptr == ' ') || (*ptr == '\t')) {
	*ptr++ = '\0';
	break;
      }
      ptr++;
    }
    if (i >= ((sizeof(argv) / sizeof(char*)) - 1)) {
      break;
    }
    while ((*ptr == ' ') || (*ptr == '\t')) {
      ptr++;
    }
  }
  argv[i] = (char*)NULL;
  status = spawnlp(P_WAIT, argv[0], argv[0], argv[1], argv[2], argv[3],
		   argv[4], argv[5], argv[6], argv[7]);
#else	/* !MSDOS */
  status = system(buff1);
#endif	/* !MSDOS */
  unlink(buff2);
  if (status) {
    print_fatal("Can't show message %d.", number);
  }
  return(status);
}

/*
 * Ѵ
 */

static int	convert_code(file1, file2, mode)
     char	*file1;
     char	*file2;
     int	mode;	/* 0:̵Ѵ 1:إå+Ѵ 2:Ѵ */
{
  FILE		*fp1, *fp2;
  short		year, month, date, day, hour, minute, second;
  register int	i, j;
  char		buff1[BUFF_SIZE];
  char		buff2[BUFF_SIZE];
  char		buff3[BUFF_SIZE];
  char		*ptr1, *ptr2;
#ifdef	MIME
  char		*ptr3, *ptr4, *ptr5;
#endif	/* MIME */

  fp1 = fopen(file1, "r");
  if (fp1 == (FILE*)NULL) {
    print_fatal("Can't read input file.");
    return(1);
  }
  signal(SIGTERM, force_exit);
  strcpy(tmp_file, file2);
  fp2 = fopen(file2, "w");
  if (fp2 == (FILE*)NULL) {
    print_fatal("Can't create output file.");
    fclose(fp1);
    return(1);
  }
  chmod(file2, S_IREAD | S_IWRITE);
  j = -1;
  buff3[0] = '\0';
  while (1) {
    if (!fgets(buff1, sizeof(buff1), fp1)) {
      break;
    }
    if (mode) {
      ptr1 = (char*)NULL;
      if ((buff1[0] == ' ') || (buff1[0] == '\t')) {
	if (j < 0) {
	  continue;
	}
	if ((int)(strlen(buff3) + strlen(buff1)) < BUFF_SIZE) {
	  strcat(buff3, buff1);
	} else {
	  j = -1;
	}
      } else {
	if (buff3[0]) {
	  ptr1 = buff2;
	  if (!j && x_nsubj_mode) {
	    recover_jis(buff2, buff3);
	  } else if ((j == 1) && jst_mode) {
	    
	    /*
	     * Date:  GMT JST ѴƥեޥåȤ줷ɽ
	     */
	    
	    convert_date(&buff3[sizeof(DATE_FIELD) - 1],
			 &year, &month, &date, &day,
			 &hour, &minute, &second, buff2);
	    strcpy(buff3, buff2);
	    sprintf(buff2, "%s %s, %d %s %04d %02d:%02d:%02d %s\n",
		    DATE_FIELD, day_string[day], date, month_string[month],
		    year, hour, minute, second, buff3);
	  } else {
#ifdef	MIME
	    if ((mime_mode) || (mode == 2)) {
	      i = 0;
	      ptr2 = buff3;
	      ptr3 = buff2;
	      ptr5 = ptr3;
	      while (*ptr2) {
		ptr4 = ptr2;
		while (*ptr4) {
		  if (*ptr4 == '\n') {
		    *ptr4++ = '\0';
		    while ((*ptr4 == '\t') || (*ptr4 == ' ')) {
		      ptr4++;
		    }
		    break;
		  } else {
		    ptr4++;
		  }
		}
		i |= mime_decode(ptr2, ptr3);
		if (kanji_strlen(ptr5) >= MAX_FIELD_COLUMN) {
		  if (ptr3 != buff2) {
		    *ptr3++ = '\n';
		    ptr5 = ptr3;
		    mime_decode(ptr2, ptr3);
		  }
		}
		while (*ptr3) {
		  ptr3++;
		}
		ptr2 = ptr4;
	      }
	      if (i) {
		*ptr3++ = '\n';
		*ptr3 = '\0';
	      } else {
		ptr4 = buff3;
		ptr3 = buff2;
		while (ptr2 != ptr4) {
		  if (*ptr4 == '\0') {
		    *ptr3++ = '\n';
		    ptr4++;
		  } else {
		    *ptr3++ = *ptr4++;
		  }
		}
		*ptr3 = '\0';
	      }
	    } else {
	      strcpy(buff2, buff3);
	    }
#else	/* !MIME */
	    strcpy(buff2, buff3);
#endif	/* !MIME */
	  }
	}
	if ((!buff1[0]) || (buff1[0] == '\n')) {
	  mode = 0;
	  if (ptr1 != (char*)NULL) {
	    strcat(ptr1, buff1);
	  } else {
	    ptr1 = buff1;
	  }
	} else {
	  if (mode == 1) {
	    j = -1;
	    for (i = 0; i < sizeof(print_field) / sizeof(char*); i++) {
	      if (!strncasecmp(buff1, print_field[i],
			       strlen(print_field[i]))) {
		j = i;
	      }
	    }
	  } else {
	    j = 999;
	  }
	  if (j < 0) {
	    buff3[0] = '\0';
	  } else {
	    strcpy(buff3, buff1);
	  }
	}
      }
    } else {
      ptr1 = buff1;
    }
    if (ptr1 != (char*)NULL) {
      if (ptr1 == buff1) {
	ptr2 = buff2;
      } else {
	ptr2 = buff1;
      }
#ifdef	MSDOS
      to_sjis(ptr2, ptr1, default_code);
#else	/* !MSDOS */
      to_euc(ptr2, ptr1, default_code);
#endif	/* !MSDOS */
      fputs(ptr2, fp2);
    }
  }
  fclose(fp1);
  fclose(fp2);
  return(0);
}

/*
 * λ
 */

static void	force_exit()
{
  if (tmp_file[0]) {
    unlink(tmp_file);
  }
  exit(1);
}
